<?php
/*
* Class Generator: un generador de código PHP 5.
* versión 0.4.0
*
* @Prometeus Technology, a subsidiary of Pegasus Tech Supply
* @copyright Copyright (C) 2008-2013 Leonardo Tadei. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see gpl-3.0.txt
* Class Generator is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

$version = '0.4';

require_once('class.classGenerator.php');

if(isset($_POST['at']) && count($_POST['at'])>0)
	$catt = count($_POST['at']); // Cantidad de Atributos
else
	$catt = 1; // Cantidad de Atributos

if(isset($_POST['met']) && count($_POST['met'])>0)
	$cmet = count($_POST['met']); // Cantidad de Atributos
else
	$cmet = 1; // Cantidad de Métodos

// Debug
//print_r($_POST);

// Limpia blancos y Restaura comillas (versión recursiva)
function Limpiar(&$vec) {
	foreach($vec as $k => $v) {
		if( is_array($v) ) {	Limpiar($v); }
		else {
		//	$vec[$k] = str_replace("\\", "" ,trim($v));
		}
	}
}
Limpiar($_POST);

// Crea una clase
$cl = new genClass('Nombre_de_la_clase');

// Setea los valores iniciales con los datos del formulario
if(isset($_POST['nom']) && $_POST['nom'] != '') { $cl->setName($_POST['nom']); }
if(isset($_POST['her'])) {
	$cl->setInherit($_POST['her']);
}
if(isset($_POST['imp'])) {
	$cl->setInterfaces($_POST['imp']);
}
if(isset($_POST['classcom'])) {
	$cl->setComment($_POST['classcom']);
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>Generador de Clases</title>
<meta name="generator" content="Bluefish 2.0.1" >
<meta name="author" content="leo" >
<meta name="date" content="2013-02-07T10:58:49-0300" >
<meta name="copyright" content="2010 Leonardo Tadei">
<meta name="keywords" content="class, generador">
<meta name="description" content="Generador de Clases PHP">

<style type="text/css">
	body{font-family: Arial;font-size:76%;margin:0;padding:0;background-color:#fcfcfc}
	#wrapper{width:60%;margin:0 auto;border:1px solid #dadada;border-top:0;padding:15px;background-color:#fff;min-width:550px;}
	h1{font-size:1.5em;position:relative;overflow:display;padding:0;margin-bottom:20px;}
	h2{font-size:1.2em;position:relative;overflow:display;padding:0;}
	table{border-collapse:collapse;width:100%;}
	tr{width:100%}
	td{padding:5px 10px 0 10px;text-align:center;}
	td.separa{border-bottom:2px solid #999;padding:5px 10px;}
	td input{border:1px solid #aaa;}
	input{padding:1px;font-size:1em;}
	textarea{display:block;width:98%;margin:0 auto;}
	#overlay{display:none;width:100%;height:100%;opacity:0.5;position:absolute;top:0;left:0;background-color:#000;z-index:9;}
	hr{width:100%;margin:10px 0;clear:both;}
	.par{background-color:#eee;}
	.impar{background-color:#f9f9f9;}
	a.add{color:#666;font-size:1.8em;text-decoration:none;vertical-align:middle;padding:0;display:block;float:right;position:relative;}
	a.add:hover{color:#000;}
	.botones{text-align:right;padding:10px 10px 0 10px;}
	.ayuda {
		position: absolute;
		z-index: 10;
		top: 70px;
		width: 640px;
		height: 480px;
		left: 50%;
		margin-left: -320px; /*Restamos la mitad de ancho para centrarlo horizontalmente*/
		border-width: 2px;
		border-color: gray;
		border-style: solid;
		background-color: white;
		visibility: hidden;
	}
	.ayudatitulo {
		background-color: #1E90FF;
		font-weight: bold;
		color: white;
	}
	.ayudanombre {
		float: left;
		background-color: #1E90FF;
		text-align: center;
		width: 70%;
		margin-left: 0;
	}
	.ayudacerrar {
		float: left;
		background-color: #1E90FF;
		text-align: right;
		width: 30%;
		margin-right: 0;
	}
	.ayudacerrar a {
		color: white;
	}
	#ayudaRes {
		width: 638px;
		margin: auto;
		background-color: #FFFFE3;
		max-height: 460px;
		overflow: auto;
	}
</style>

<script type="text/javascript" >
	var catt=<?=$catt?>;
	var cmet=<?=$cmet?>;

	function ayudaSwitch() {
		// conmuta visible o no la
		if ( document.getElementById('ayuda').style.visibility == 'visible' ) {
			document.getElementById('overlay').style.display = 'none';
			document.getElementById('ayuda').style.visibility = 'hidden';
			document.body.style.overflow = 'auto';
		} else {
			document.getElementById('overlay').style.display = 'block';
			document.getElementById('ayuda').style.visibility = 'visible';
			document.body.style.overflow = 'hidden';
		}
	}
	/*
	Funcion: genera un nuevo elemento en el DOM del documento.
	Parametros:
		- tipo (cadena): define el tipo de elemento a generar, recibe el nombre de la etiqueta (por ej: a, p, div).
		- opciones (objeto): define las opciones del objeto. Las soportadas son:
			. padre: el elemento o id del elemento padre, donde se insertara el nuevo elemento.
			. nombre: el nombre que será declarado en la propiedad "name".
			. valor: el valor declarado en la propiedad "value".
			. texto: el contenido del elemento.
			. tipo: el tipo declarado en la propiedad "type".
	Devuelve:
		- (objeto) devuelve el elemento.
	*/
	function nuevoElemento(tipo,opciones){
		if(typeof(opciones.padre)=='string')
			var parent = document.getElementById(opciones.padre);
		else
			var parent = opciones.padre;
		var newEl = document.createElement(tipo);
		if(opciones.nombre) newEl.name = opciones.nombre;
		if(opciones.valor) newEl.value = opciones.valor;
		if(opciones.texto) newEl.innerHTML = opciones.texto;
		if(opciones.tipo) newEl.type = opciones.tipo;
		if(opciones.id) newEl.id = opciones.id;
		if(opciones.class) newEl.className = opciones.class;
		if(opciones.size) newEl.size = opciones.size;
		if(opciones.colspan) newEl.colSpan = opciones.colspan;
		parent.appendChild(newEl);
		return newEl;
	}

	/*
	Funcion: genera un nuevo nodo de texto en el DOM del documento y lo añade a un padre.
	Parametros:
		- str (cadena): el texto.
		- parent (objeto): el objeto padre al cual agregar el nodo
	Devuelve:
		- (objeto) devuelve el nodo.
	*/
	function nuevoTexto(str,parent){
		if(typeof(parent)=='string')
			parent = document.getElementById(parent);
		var x = document.createTextNode(str);
		parent.appendChild(x);
		return x;
	}

	/*
	Funcion: genera una fila en la tabla que contenga un select y dos input.
	Parametros:
		- bodyname (cadena): el id del tbody de la tabla donde se insertará la fila.
		- selname (cadena): el nombre que se le asignará al select.
		- input1name (cadena): el nombre que se le asignará al primer input.
		- input2name (cadena): el nombre que se le asignará al segundo input.
	Devuelve:
		- (bool) Siempre devuelve verdadero.
	*/
	function newRow(bodyname,selname,input1name,input2name,commentsname,count){
		clase = (count%2?'impar':'par');
		count++;

		// Genero el tr y lo inserto en la tabla
		var tr = nuevoElemento('tr',{'padre':bodyname,'class':clase});

		// Genero un nuevo td y lo inserto en el tr
		var td = nuevoElemento('td',{'padre':tr});

		// Genero el select con sus opciones y lo inserto en el td
		if (bodyname == 'metodosBody') {
			var el1 = nuevoElemento('select',{'padre':td,'nombre':selname});
			var el4 = nuevoElemento('option',{'padre':el1,'valor':'public','texto':'Public'});
			var el3 = nuevoElemento('option',{'padre':el1,'valor':'protected','texto':'Protected'});
			var el2 = nuevoElemento('option',{'padre':el1,'valor':'private','texto':'Private'});
		} else {
			var el1 = nuevoElemento('select',{'padre':td,'nombre':selname});
			var el2 = nuevoElemento('option',{'padre':el1,'valor':'private','texto':'Private'});
			var el3 = nuevoElemento('option',{'padre':el1,'valor':'protected','texto':'Protected'});
			var el4 = nuevoElemento('option',{'padre':el1,'valor':'public','texto':'Public'});
		}
		// Vuelvo a generar un td con el input adentro y lo inserto en el tr
		td = nuevoElemento('td',{'padre':tr});
		el1 = nuevoElemento('input',{'padre':td,'tipo':'text','nombre':input1name});

		// Vuelvo a generar un td con el input adentro y lo
		td = nuevoElemento('td',{'padre':tr});
		if(bodyname=='metodosBody') nuevoTexto('( ',td);
		el1 = nuevoElemento('input',{'padre':td,'tipo':'text','nombre':input2name});
		if(bodyname=='metodosBody') nuevoTexto(' )',td);

		// Genero la segunda fila, para el comentario
		tr = nuevoElemento('tr',{'padre':bodyname,'class':clase});
		td = nuevoElemento('td',{'padre':tr,'colspan':3,'class':'separa'});
		nuevoTexto('Comentario: ',td);
		el1 = nuevoElemento('input',{'padre':td,'tipo':'text','nombre':commentsname,'size':60});

		return count;
	}

	/*
		Funcion: Llama a la funcion newRow para crear una nueva fila en la tabla de atributos
	*/
	function nuevoAtributo(){
		catt = newRow('atributosBody','visat[]','at[]','val[]','comat[]',catt);
	}

	/*
		Funcion: Llama a la funcion newRow para crear una nueva fila en la tabla de metodos
	*/
	function nuevoMetodo(){
		cmet = newRow('metodosBody','vismet[]','met[]','msg[]','commet[]',cmet);
	}
</script>

</head>

<body>
	<div id="wrapper">
		<h1>Generador de Clases PHP <a class="add" href="javascript: ayudaSwitch();" title="Ayuda">?</a></h1>
		<form action="?" name="fgen" method="post">
			<h2>Definici&oacute;n de la Clase:</h2>
			<label>Nombre: <input type="text" name="nom" id="nom" value="<?=$cl->getName()?>"></label><br >
			<label>Hereda de: <input type="text" name="her" id="her" value="<?=$cl->getInherit()?>"></label>
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<label>Interfaces que Implementa: <input type="text" name="imp" id="imp" value="<?=$cl->getInterfaces()?>"></label><br >
			<label>
				Comentarios de la clase:<br> <textarea name="classcom" id="classcom" cols="50" rows="2"><?=$cl->getComment()?></textarea>
			</label>
			<hr>

			<h2>Atributos: <a href="#" class="add" onclick="nuevoAtributo()" title="Nuevo Atributo">+</a></h2>
			<table>
				<tbody id="atributosBody">
					<tr>
						<th>Visibilidad</th>
						<th>Nombre (sin $)</th>
						<th>Valor Inicial</th>
					</tr>
<?php
for($i=0;$i<$catt;$i++) {
	$clase = ($i%2?'impar':'par');
?>
					<tr class="<?=$clase?>">
						<td>
							<select name="visat[]" id="visat<?=$i?>">
								<option value="private" <?php if(isset($_POST["visat"][$i]) && $_POST["visat"][$i] == 'private') { print ("selected"); } ?>>Private</option>
								<option value="protected" <?php if(isset($_POST["visat"][$i]) && $_POST["visat"][$i] == 'protected') { print ("selected"); } ?>>Protected</option>
								<option value="public" <?php if(isset($_POST["visat"][$i]) && $_POST["visat"][$i] == 'public') { print ("selected"); } ?>>Public</option>
							</select>
						</td>
						<td><input type="text" name="at[]" id="at<?=$i?>" value="<?php if(isset($_POST["at"][$i])) { print $_POST["at"][$i]; } ?>"></td>
						<td><input type="text" name="val[]" id="val<?=$i?>" value="<?php if(isset($_POST["val"][$i])) { print $_POST["val"][$i]; } ?>"></td>
					</tr>
					<tr class="<?=$clase?>">
						<td colspan="3" class="separa">
							Comentario: <input type="text" name="comat[]" id="comat<?=$i?>" size="60" value="<?php if(isset($_POST["comat"][$i])) {print $_POST['comat'][$i]; }?>">
						</td>
					</tr>
<?php
}
?>
				</tbody>
			</table>

			<h2>M&eacute;todos: <a href="#" class="add" onclick="nuevoMetodo()" title="Nuevo M&eacute;todo">+</a></h2>
			<table>
				<tbody id="metodosBody">
					<tr>
						<th>Visibilidad</th>
						<th>Nombre</th>
						<th>Mensaje(s)</th>
					</tr>
<?php
for($i=0;$i<$cmet;$i++) {
	$clase = ($i%2?'impar':'par');
?>
					<tr class="<?=$clase?>">
						<td>
							<select name="vismet[]" id="vismet<?=$i?>">
								<option value="public" <?php if( isset($_POST["vismet"][$i]) && $_POST["vismet"][$i] == 'public') { print ("selected"); } ?>>Public</option>
								<option value="protected" <?php if( isset($_POST["vismet"][$i]) && $_POST["vismet"][$i] == 'protected') { print ("selected"); } ?>>Protected</option>
								<option value="private" <?php if( isset($_POST["vismet"][$i]) && $_POST["vismet"][$i] == 'private') { print ("selected"); } ?>>Private</option>
							</select>
						</td>
						<td><input type="text" name="met[]" id="met<?=$i?>" value="<?php if(isset($_POST["met"][$i])) { print $_POST["met"][$i]; } ?>"></td>
						<td> ( <input type="text" name="msg[]" id="msg<?=$i?>" value="<?php if(isset($_POST["msg"][$i])) { print $_POST["msg"][$i]; } ?>"> ) </td>
					</tr>
					<tr class="<?=$clase?>">
						<td colspan="3" class="separa">
							Comentario: <input type="text" name="commet[]" id="commet<?=$i?>" value="<?php if(isset($_POST["commet"][$i])) { print $_POST["commet"][$i]; }?>" size="60">
						</td>
					</tr>
<?php
}
?>
				</tbody>
			</table>

			<div class="botones">
				<input type="submit" name="Bgen" value="Generar !">
				<input type="button" onclick="location.reload(true)" value="Limpiar">
			</div>
		</form>

<?php
if( isset($_POST['Bgen'])) {
	// Genera el código:
	// Crea los atributos y los agrega a la clase
	foreach($_POST['at'] as $k => $ele){
		if($ele != '') {
			$att = new genAttribute($ele, $_POST['val'][$k], $_POST['comat'][$k], $_POST['visat'][$k] );
			$cl->attributes->add($att);
		}
	}
	// Crea los métodos y los agrega a la clase
	foreach($_POST['met'] as $k => $ele){
		if($ele != '') {
			$met = new genMethod($ele, $_POST['msg'][$k], $_POST['commet'][$k], $_POST['vismet'][$k] );
			$cl->methods->add($met);
		}
	}
?>
		<hr class="barra">
		<h2>C&oacute;digo generado:</h2>
		<textarea cols="80" rows="30"><?php print($cl->toCode()); ?></textarea>
<?php
} // 	if( isset($_POST['Bgen']))
?>
	</div>

	<div id="overlay"></div>
	<div id="ayuda" class="ayuda">
		<div class="ayudatitulo">
			<div class="ayudanombre">
				Generador de Clases PHP - versi&oacute;n 0.3 - Ayuda
			</div>
			<div class="ayudacerrar">
				<a href="javascript: ayudaSwitch();"> Cerrar X</a>&nbsp;&nbsp;&nbsp;&nbsp;
			</div>
		</div>
		<div id="ayudaRes">
		<p><b>Generador de Clases PHP</b> es un utilitario para generar c&oacute;digo <i>PHP 5</i> con el
		esqueleto de una clase. Permite definir atributos, su visibilidad (el principio de
		encapsulaci&oacute;n dice que los atributos siempre deben ser privados, pero permite cambiarlo)
		y un valor inicial; tambi&eacute;n permite definir los m&eacute;todos de la clase y su visibilidad.
		<br>
		El c&oacute;digo generado respeta las may&uacute;sculas y min&uacute;sculas, como as&iacute;
		tambi&eacute;n las comillas.
		<br>
		El Generador de Clases PHP no hace, porque no puede, ninguna validaci&oacute;n de tipos,
		casting, o de si el c&oacute;digo generado tiene sentido sint&aacute;ctico o sem&aacute;ntico.
		Esto es epecialmente importante en los mensajes de los m&eacute;todos, que se espera sean
		escritos en PHP.
		</p>

		<ul>
			<li>
				<b>Definici&oacute;n de la Clase:</b> ser&aacute; el nombre de la clase a generar, y si es que tiene,
				su superclase e interfaces que implementa.
				<br><br>
			</li>
			<li>
				<b>Atributos:</b> ser&aacute;n los atributos de la clase. El valor inicial puede estar vac&iacute;o.
			En caso de valores iniciales "string", es recomendable ingresarlos entre comillas.
				<br><br>
			</li>
			<li>
				<b>M&eacute;todos:</b> ser&aacute;n los m&eacute;todos de la clase. Se generan autom&aacute;ticamente
			el <i>constructor</i>,  <i>__tostring</i> vac&iacute;os y los <i>setters</i> y <i>getters</i> de
			los atributos con el c&oacute;digo para accederlos. De tener mensajes, se ingresan con un $ delante y
			separados por comas.
				<br><br>
			</li>
		</ul>
		Happy hacking!
		<hr>
		<p><b>Licencia:</b> Generador de Clases PHP es distribuido bajo licencia GPL v3 o superior.
		Copyright 2013 Leonardo Tadei &lt;leonardot@pegasusnet.com.ar&gt;<br>
		Todos los derechos reversados. </p>
		<p>
	@Prometeus Technology, a subsidiary of Pegasus Tech Supply<br>
	@copyright Copyright (C) 2008-2013 Leonardo Tadei. All rights reserved.<br>
	@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see gpl-3.0.txt<br>
	Class Generator is free software. This version may have been modified pursuant
	to the GNU General Public License, and as distributed it includes or
	is derivative of works licensed under the GNU General Public License or
	other free or open source software licenses.
		</p>
		<hr>
		<i>Versi&oacute;n 0.4:</i> Adaptaci&oacute;n del c&oacute;digo para PHP5.3 Strict Standards. Esta versi&oacute;n de PHP
		no cumple con el Principio de Substituci&oacute;n de Liskov, y ahora las colecciones de atributos y de m&eacute;todos
		no est&aacute;n casteadas. 
		<br>
		<i>Versi&oacute;n 0.3.1:</i> Remaquetacion y redise&ntilde;o de la GUI por Matias Gea &lt;matigea@gmail.com&gt;.
		<br>
		<i>Versi&oacute;n 0.3:</i> Reimplementaci&oacute;n en Objetos del core generador de clases.
		Separaci&oacute;n completa de la generaci&oacute;n de c&oacute;digo de la GUI.
		Agregada la posibilidad de crear comentarios a los atributos y a los m&eacute;todos.
		<br>
		<i>Versi&oacute;n 0.2:</i> Agrega la posibilidad de definir la superclase de la clase a generar,
		las interfaces que implementa, un comentario a la clase y genera el m&eacute;todo toString.
		<br>
		<i>Versi&oacute;n 0.1:</i> Genera una clase en PHP 5 basada en un nombre ingresado, los atributos y la
		generaci&oacute;n autom&aacute;tica de setters y getters, un constructor los m&eacute;todos indicados.
		</div>
	</div>
</body>
</html>
