<?php
/*
* @Facultad de Ingeniería, Universidad Nacional de Mar del Plata
* @copyright Copyright (C) 2015 Leonardo Tadei. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see gpl-3.0.txt
* Panel de Estado is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/
class Estado {
	/*
	* Atributos
	*/
	private $id;	
	private $nom;	
	/*
	* Metodos
	*/
	public function __construct($nom='') {
		$this->setNom($nom);
	}
	public function getCSSpanel() {
		$res = '';
		switch($this->getId()) {
			case 1:	$res=' panel-success '; break;	
			case 2:	$res=' panel-warning '; break;	
			case 3:	$res=' panel-danger '; break;	
		}
		return $res;
	}
	/*
	* Setters y Getters
	*/
	public function setId($v) {
      // Setter de un solo uso
		if( is_null($this->getId())) {
			$this->id = $v;
		} else {
			throw new Exception('Estado: el ID no puede ser cambiado');	
		}
	}
	public function getId() {
		return $this->id;
	}
	public function setNom($v) {
		$this->nom = $v;
	}
	public function getNom() {
		return $this->nom;
	}
	public function __toString() {
		return "class Estado";
	}
}	// class Estado

class CollectionEstado implements IteratorAggregate {
    private $items = array();
    // Métodos
    public function getIterator() {
        return new ArrayIterator($this->items);
    }
    public function add(Estado $obj) {
        $this->items[] = $obj;
    }
    public function getById($id) {
    	// Devuelve un objeto por su ID o falso
    	foreach($this->items as $o){
			if($id==$o->getId()) {
				return $o;
			}    	
    	}
    	return null;
    }
}