<?php
/*
* @Facultad de Ingeniería, Universidad Nacional de Mar del Plata
* @copyright Copyright (C) 2015 Leonardo Tadei. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see gpl-3.0.txt
* MicroODBMS is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*
* microODBMS orientado a persistir y recobrar Objetos de cualquier tipo, guardados en archivos.
*
* 2015-12-02 - Primer release
*/

class microODBMS{
	private $path='';
	private $extension='od';

	function __construct($path='data/', $extension='od'){
		$this->setPath($path);
		$this->setExtension($extension);
	}

	function show() {
		// devuelve el listado de todos los almacenamientos existentes para la extensión
		$tmp = scandir($this->getPath());
		$res = array();
		$ext = '.'.$this->getExtension();
		$l = strlen($ext) * (-1);
		foreach($tmp as $a){
			$ea = substr($a, $l);
			if($ext == $ea) {
				$res[] = substr($a,0,$l);
			}
		}
		return $res;
	}

	function retrieve($q) {
		// Devuelve un Objeto
		$fn = $this->getPath().$q.'.'.$this->getExtension();
		if( ! file_exists($fn)) {
			throw new Exception("microODBMS: $fn no existe");
		}
		// $size = filesize($fn);
		$handle = fopen($fn, 'r');	// lee todo el archivo.
		if($handle === false) {
			throw new Exception("microODBMS: $fn no se puede abrir");
		}
		$lenght = filesize($fn);
		$os = fread($handle, $lenght);
		return unserialize($os); ;
	}
	
	function save($o, $q) {
		// persiste un Objeto
		$fn = $this->getPath().$q.'.'.$this->getExtension();
		$s = serialize($o);
		$handle = fopen($fn, 'w');	// sobreescribe el archivo
		if($handle === false) {
			throw new Exception("microODBMS: $fn no se puede escribir");
		}
		$res = fwrite($handle, $s);
		if($res === false) {
			throw new Exception("microODBMS: $fn fallo al escribir");		
		}
		return $res;
	}

	function setPath($v) { $this->path = $v; }
	function getPath() { return $this->path; }

	function setExtension($v) { $this->extension = $v; }
	function getExtension() { return $this->extension; }
}
